module CParser

  # returns a parser that finds c and c++ comments.
  def CParser.create_parser

    lexer = Lexer.new( [[%r{\A/\* \*+ /}mx, ?n], # Null c style comment
                        [%r{\A/ \*+ ([^\*]+ \*+)+? / }mx,?c], # C style comment
                        [%r{\A// [^\n]* (\n | $ )}mx,?p], # C++ style comment
                        [%r{\A [^/]+ (/ [^/\*] [^/]*)* }mx,?d]], # C code
                       false)

    return lexer
  end
end
