# Parser's a useful (to me that is) subset of the Graphviz "dot"
# language for digraphs. See http://www.graphviz.org/ for details

module DiGraphParser

  def DiGraphParser.create_parser
    lexer = Lexer.new([[/\A\s+/,?\s ],  # Whitespace, space char
                       [/\Adigraph/,?d], # keyword "digraph", 'd' 
                       [/\A[a-zA-Z_][a-zA-Z0-9_]*/, ?i], # identifier 'i'
                       [/\A=/ , ?=], # Assignment operator, '='
                       [/\A\[/, ?[], # Open square brackets (for attributes), '['
                       [/\A\]/, ?]], # Close square brackets (for attributes), ']'
                       [/\A->/, ?>], # Edge operator, '>'
                       [/\A\{/, ?{], # Braces for graph's and sub-graphs
                       [/\A\}/, ?}],
                       [/\A;/, ?;]]) # Semicolon ';'
    
    parser = Lexer.new([[/\Adi\{/,?h], # A digraph is a header 'h'
                        [/\Ai( > i)+;/x,?e], # one or more edges 'e'
                        [/\Ai(\[i=i\])?;/,?n], # And nodes with perhaps attributes 'n'
                        [/\A\};?/,?t]]) # Followed by trailer }; 't'

    return lexer, parser
  end

end
