module HtmlParser
  
  # A very simple very forgiving lexical scanner and parser
  # for HTML 4
  #
  # Returns a lexical scanner, and a lexical scanner for tags.
  def HtmlParser.create_parser

    lexer = Lexer.new( [[%r{\A<!-- .*? -->}m,?c], # HTML comments 'c'
                        [%r{\A<![^>]+>}m,?d], # SGML declarations 'd'
                        [%r{\A</[^>]+>}m,?e], # End tag 'e'
                        [%r{\A<[^>]+>}m,?s],  # Starg tag 's'
                        [%r{\A[^<]+}m,?f]], # cdata segment. 'f'
                       false)

    tag_lexer = Lexer.new( [[ %r{\A</}m, ?/], # </ end tag open '/'
                            [ %r{\A<}m, ?<],  # open tag '<'
                            [ %r{\A>}m, ?>],  # close tag '>'
                            [ %r{\A("[^\"]*"|'[^\']*')}m,?t], # String 't'
                            [ %r{\A\s+}m, ?\s], # Whitespace ' '
                            [ %r{\A=}m, ?=], # Assigment '='
                            [ %r{\A[a-zA-Z][:a-zA-Z_0-9]*}m,?i], # Identifier 'i'
                            [ %r{\A[0-9]+(?![a-zA-Z_])}m, ?0]], # Number '0'
                           true) # Ignores whitespace
                           

    return lexer, tag_lexer
  end
end
